# Dirac - A Video Codec

Created by the British Broadcasting Corporation.

# dirac::PixelMatcher Class Reference

`#include <pixel_match.h>`

Collaboration diagram for dirac::PixelMatcher:

[legend]
List of all members.

## Public Member Functions

- PixelMatcher (const EncoderParams &encp)
    Constructor.
- void DoSearch (const FrameBuffer &my_buffer, int frame_num, MEData &me_data)
    Do the actual search.

## Private Member Functions

- void MakePicHierarchy (const PicArray &data, OneDArray< PicArray * > &down_data)
    Make down-converted pictures.
- void MakeMEDataHierarchy (const OneDArray< PicArray * > &down_data, OneDArray< MEData * > &me_data_set)
    Make a hierarchy of MvData structures.
- void TidyPics (OneDArray< PicArray * > &down_data)
    Tidy up the allocations made in building the picture hirearchy.
- void TidyMEData (OneDArray< MEData * > &me_data_set)
    Tidy up the allocations made in building the MV data hirearchy.
- void MatchPic (const PicArray &ref_data, const PicArray &pic_data, MEData &me_data, const MvData &guide_data, const int ref_id)
    Match the picture data.
- void DoBlock (const int xpos, const int ypos, TwoDArray< MvCostData > &pred_costs, MvArray &mv_array, const MvArray &guide_array, BlockMatcher &block_match)
    Do a given block.

## Private Attributes

- const EncoderParams & m_encparams
    Local reference to the encoder.
- int m_depth
- int m_level
- int m_xr
- int m_yr
- FrameSort m_fsort
- CandidateList m_cand_list
- float m_lambda
- MVector m_mv_prediction

## Constructor & Destructor Documentation

dirac::PixelMatcher::PixelMatcher | ( | const EncoderParams & | encp | ) |

## Member Function Documentation

void dirac::PixelMatcher::DoBlock | ( | const int | xpos,
|  | const int | ypos,
|  | TwoDArray< MvCostData > & | pred_costs,
|  | MvArray & | mv_array,
|  | const MvArray & | guide_array,
|  | BlockMatcher & | block_match |
| ) |  |  | `[private]`

void dirac::PixelMatcher::DoSearch | ( | const FrameBuffer & | my_buffer,
|  | int | frame_num,
|  | MEData & | me_data |
| ) |  |  |

void dirac::PixelMatcher::MakeMEDataHierarchy | ( | const OneDArray< PicArray * > & | down_data,
|  | OneDArray< MEData * > & | me_data_set |
| ) |  |  | `[private]`

void dirac::PixelMatcher::MakePicHierarchy | ( | const PicArray & | data,
|  | OneDArray< PicArray * > & | down_data |
| ) |  |  | `[private]`

void dirac::PixelMatcher::MatchPic | ( | const PicArray & | ref_data,
|  | const PicArray & | pic_data,
|  | MEData & | me_data,
|  | const MvData & | guide_data,
|  | const int | ref_id |
| ) |  |  | `[private]`

void dirac::PixelMatcher::TidyMEData | ( | OneDArray< MEData * > & | me_data_set | ) | `[private]`

void dirac::PixelMatcher::TidyPics | ( | OneDArray< PicArray * > & | down_data | ) | `[private]`

## Member Data Documentation

CandidateList dirac::PixelMatcher::m_cand_list`[private]`

int dirac::PixelMatcher::m_depth`[private]`

const EncoderParams& dirac::PixelMatcher::m_encparams`[private]`

FrameSort dirac::PixelMatcher::m_fsort`[private]`

float dirac::PixelMatcher::m_lambda`[private]`

int dirac::PixelMatcher::m_level`[private]`

MVector dirac::PixelMatcher::m_mv_prediction`[private]`

int dirac::PixelMatcher::m_xr`[private]`

int dirac::PixelMatcher::m_yr`[private]`

The documentation for this class was generated from the following file:

- pixel_match.h

© 2004 British Broadcasting Corporation. Dirac code licensed under the Mozilla Public License (MPL) Version 1.1.
HTML documentation generated by Dimitri van Heesch's excellent Doxygen tool.